VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form Pies 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Pie Database Demo"
   ClientHeight    =   4230
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   6405
   BeginProperty Font 
      Name            =   "Microsoft Sans Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Pies.frx":0000
   LinkTopic       =   "Pies"
   MaxButton       =   0   'False
   ScaleHeight     =   4230
   ScaleWidth      =   6405
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdAddPie 
      Caption         =   "Add a Pie"
      Default         =   -1  'True
      Height          =   495
      Left            =   2580
      TabIndex        =   0
      Top             =   3600
      Width           =   1245
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid flexPies 
      Height          =   2955
      Left            =   45
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   480
      Width           =   6315
      _ExtentX        =   11139
      _ExtentY        =   5212
      _Version        =   393216
      SelectionMode   =   1
      AllowUserResizing=   1
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
   Begin VB.Label lblPies 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Pies"
      BeginProperty Font 
         Name            =   "Microsoft Sans Serif"
         Size            =   14.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   45
      TabIndex        =   2
      Top             =   60
      Width           =   6315
   End
End
Attribute VB_Name = "Pies"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
'Demonstration of MDB creation with related tables and the use of Jet
'Simple Parameter Queries, Prepared Queries, Stored Views and Procedures,
'and Command objects and Stored Procedures as extended Connection methods.
'
'Some of these features can only be used via the Jet OLE DB Provider 4.0
'and cannot be used or seen via MS Access, DAO, or ODBC.
'
Private Const MDB_NAME As String = "Pie"
Private Const FRUITS_NAME As String = "Source Data\Fruits.txt"
Private Const PIES_NAME As String = "Source Data\Pies.txt"
Private Const WG_CONNSTRING As String = _
      "Provider=Microsoft.Jet.OLEDB.4.0;Jet OLEDB:Engine Type=5;" _
    & "Jet OLEDB:Create System Database=True;" _
    & "Data Source='$MDB$.mdw'"
Private Const DB_CONNSTRING As String = _
      "Provider=Microsoft.Jet.OLEDB.4.0;Jet OLEDB:Engine Type=5;" _
    & "Jet OLEDB:System Database='$MDB$.mdw';" _
    & "Data Source='$MDB$.mdb'"

Public PieAdded As Boolean 'Return signal from Form AddPie.
Public cnDB As ADODB.Connection 'Also used by Form AddPie.

Private Sub CreateDB()
    'Exits with new MDB created, populated from initial data
    'in text files, and cnDB left open.
    
    Dim catDB As Object 'Don't early-bind ADOX objects.
    
    Set catDB = CreateObject("ADOX.Catalog")
    catDB.Create Replace$(WG_CONNSTRING, "$MDB$", MDB_NAME)
    catDB.Create Replace$(DB_CONNSTRING, "$MDB$", MDB_NAME)
    
    Set cnDB = catDB.ActiveConnection
    With cnDB
        .Execute "CREATE TABLE Fruits (" _
               & "FruitID IDENTITY NOT NULL CONSTRAINT PK_FruitID PRIMARY KEY," _
               & "Fruit TEXT(50) WITH COMPRESSION NOT NULL UNIQUE" _
               & ")", _
                 , adCmdText
        .Execute "CREATE TABLE Pies (" _
               & "PieID IDENTITY NOT NULL CONSTRAINT PK_PieID PRIMARY KEY," _
               & "Pie TEXT(50) WITH COMPRESSION NOT NULL," _
               & "FruitID INTEGER NOT NULL CONSTRAINT FK_FruitID " _
               & "REFERENCES Fruits (FruitID)" _
               & ")", _
                 , adCmdText
        .Execute "CREATE VIEW PiesView (ID, Pie, Fruit) AS " _
               & "SELECT PieID AS ID, Pie, Fruit " _
               & "FROM Pies LEFT OUTER JOIN Fruits " _
               & "ON Pies.FruitID = Fruits.FruitID", _
                 , adCmdText
        .Execute "CREATE PROC InsertPie(NewPie TEXT(50), FruitName TEXT(50)) AS " _
               & "INSERT INTO Pies (Pie, FruitId) " _
               & "SELECT NewPie, Fruits.FruitId FROM Fruits " _
               & "WHERE Fruit = FruitName", _
                 , adCmdText
    End With
    
    Populate
End Sub

Private Sub Populate()
    Dim cmInsertFruit As ADODB.Command
    Dim intFile As Integer
    Dim strFruit As String
    Dim strPie As String
    
    'Define transient Command for temporary multiple use.  We could
    'also have used a Stored Procedure but we only need it here.
    Set cmInsertFruit = New ADODB.Command
    With cmInsertFruit
        .Name = "InsertFruit"
        .Prepared = True
        .CommandType = adCmdText
        .CommandText = "INSERT INTO Fruits (Fruit) VALUES (?)"
        Set .ActiveConnection = cnDB
    End With
    
    'Populate [Fruits].
    intFile = FreeFile(0)
    Open FRUITS_NAME For Input As #intFile
    Do Until EOF(intFile)
        Input #intFile, strFruit
        cnDB.InsertFruit strFruit
    Loop
    Close #intFile
    'Make this table effectively read only.
    cnDB.Execute "REVOKE DELETE, INSERT, UPDATE ON TABLE Fruits FROM ADMIN, PUBLIC"
    
    'Populate [Pies].
    intFile = FreeFile(0)
    Open PIES_NAME For Input As #intFile
    Do Until EOF(intFile)
        Input #intFile, strPie, strFruit
        cnDB.InsertPie strPie, strFruit
    Loop
    Close #intFile
End Sub

Private Sub OpenExistingDB()
    Set cnDB = New ADODB.Connection
    cnDB.Open Replace$(DB_CONNSTRING, "$MDB$", MDB_NAME)
End Sub

Private Sub GridFirstPaint()
    Dim intCol As Integer
    
    With flexPies
        .AllowUserResizing = flexResizeColumns
        .SelectionMode = flexSelectionByRow
        .Cols = 3
        .Row = 0
        For intCol = 0 To 2
            .ColWidth(intCol) = _
                TextWidth(String(Choose(intCol + 1, 3, 17, 16), "M"))
            .Col = intCol
            .CellAlignment = flexAlignCenterCenter
            .CellFontBold = True
            .Text = Choose(intCol + 1, "ID", "Pie", "Fruit")
        Next
    End With
    
    GridRepaint
End Sub

Private Sub GridRepaint()
    Dim rsPiesView As ADODB.Recordset
    Dim fldID As ADODB.Field
    Dim fldPie As ADODB.Field
    Dim fldFruit As ADODB.Field
    
    Set rsPiesView = New ADODB.Recordset
    With rsPiesView
        'Select a firehose cursor.
        .CursorType = adOpenForwardOnly
        .LockType = adLockReadOnly
        cnDB.PiesView rsPiesView
        'Optimize Field access in the loop below.
        Set fldID = !ID
        Set fldPie = !Pie
        Set fldFruit = !Fruit
        With flexPies
            .Redraw = False
            .Rows = 2 'Must be 1 more than FixedRows.
            .Row = 0
            Do Until rsPiesView.EOF
                .Row = .Row + 1
                .Col = 0: .Text = fldID.Value
                .Col = 1: .Text = fldPie.Value
                .Col = 2: .Text = fldFruit.Value
                rsPiesView.MoveNext
                If Not rsPiesView.EOF Then
                    .Rows = .Rows + 1
                End If
            Loop
            .Redraw = True
            lblPies.Caption = CStr(.Rows - 1) & " Pies"
        End With
        .Close
    End With
End Sub

Private Function FileExists(ByVal FileName As String) As Boolean
    On Error Resume Next
    GetAttr FileName
    FileExists = Err.Number = 0
End Function

Private Sub cmdAddPie_Click()
    AddPie.Show vbModal, Me
    If PieAdded Then GridRepaint
End Sub

Private Sub Form_Load()
    Show
    
    'Open (or create and populate) MDB.
    If FileExists(MDB_NAME & ".mdb") Then
        OpenExistingDB
    Else
        CreateDB
    End If
    
    'Paint grid.
    GridFirstPaint
End Sub

Private Sub Form_Unload(Cancel As Integer)
    cnDB.Close
End Sub
